<script>
    import { dataset_dev } from "svelte/internal";
    import { max, min } from "d3-array";
    import { select } from "d3-selection";
    import {  scaleLinear, scaleLog  } from "d3-scale";
    export let data = [];
    export let checked_scaling;

    // Size and margins
    const width = 600;
    const height = 250;
    const margin = { top: 10, right: 10, bottom: 10, left: 10 };
    const innerWidth = width - margin.left - margin.right;
    const innerHeight = height - margin.top - margin.bottom;

    let building_types = ["FullServiceRestaurant", "Hospital", "LargeHotel", "LargeOffice", "MediumOffice", "MidriseApartment", "OutPatient", 
  "PrimarySchool", "QuickServiceRestaurant", "SecondarySchool", "SmallHotel", "SmallOffice", "Stand-aloneRetail", "StripMall", "SuperMarket", "Warehouse"];

  // let building_types = ["SuperMarket"]

  function extract_data(data, building_type){
    return data.filter(datum => datum.buildingtype == building_type);
  }


  function get_path(data, building_type, builting_idx, checked_scaling){
    let min_;
    let max_;

    if(checked_scaling == "across_all_building_types"){
      min_ = min(data, function(d) { return d.total_heating_energy; });
      max_ = max(data, function(d) { return d.total_heating_energy; });
    } else if (checked_scaling == "within_building_type") {
      min_ = min(extract_data(data, building_type), function(d) { return d.total_heating_energy; });
      max_ = max(extract_data(data, building_type), function(d) { return d.total_heating_energy; });
    } else {
      console.log("No such scaling type!");
    }


    data = extract_data(data, building_type);


    const xScale = scaleLinear().domain([0, data.length]).range([70, innerWidth]);
    const yScale = scaleLinear().domain([min_, max_]).range([innerHeight - (builting_idx)*5, innerHeight-(builting_idx+1)*5]);

    let path = "M " + xScale(0) + " " + yScale(min_) + " C ";
    for(let i=0; i<data.length; i++){
      path += xScale(i) + " " + yScale(data[i].total_heating_energy) + " ";
    }

    // path += "M " +  xScale(data.length-1) + " " + yScale(data[data.length-1].total_heating_energy) + " C " 
    for(let i=data.length-1; i>=0; i--){
      path += xScale(i) + " " + (yScale(2*data[i].total_heating_energy) ) + " ";
    }
    return path;
  }
</script>


<svg {width} {height}>
    <g transform="translate({margin.left}, {margin.top})">
      {#each building_types as builting_type, i}
        <path d={get_path(data, builting_type, 3*i, checked_scaling)} fill="black" stroke="black"></path>
        <text class="building_type_name" x={0} y={(3*i*5)}>{builting_type}</text>
      {/each}
    </g>
  </svg>
  
  <style>
    svg {
      border: 1px solid black;
      border-radius: 5px;
    }

    .building_type_name{
      font-size: 6px;
    }
  </style>
  